include LISWatch.inc
include ../CmnHdr.inc

;**********************CODE SEGMENT*********************************
.code 
start:;START PROG HERE. 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke	InitCommonControls
		invoke	DialogBoxParam,hInstance,IDD_LISWATCH ,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;***********CalcWndText PROCEDURE********************************
CalcWndText proc uses esi hwnd:dword,pszBuf:dword, nLen:dword
local szClass[50]:byte, szCaption[50]:byte, szBufT[150]:byte

	.if hwnd ==  NULL	
		invoke lstrcpy,pszBuf, SADD("(no window)")
		ret
	.endif
	
	invoke IsWindow,hwnd
	.if !eax
		invoke lstrcpy,pszBuf, SADD("(invalid window)")
		ret
	.endif
	
	invoke GetClassName,hwnd,addr szClass,sizeof szClass
	invoke GetWindowText,hwnd,addr szCaption, sizeof szCaption
	.if [szCaption] == 0
		invoke wsprintf,addr szBufT, SADD("[%s] %s"), addr szClass,SADD("(no caption)")	
	.else
		invoke wsprintf,addr szBufT, SADD("[%s] %s"), addr szClass,addr szCaption	
	.endif
	mov esi,nLen
	dec esi
	invoke lstrcpy,pszBuf,addr szBufT
	mov pszBuf[esi+1],0;Force zero-terminated string
	
	ret
CalcWndText endp
;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local pt:POINT,		szBuf[100]:byte,	hTemp:dword
local hwndForeground:dword,		dwThreadIdAttachTo:dword

		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			chSETDLGICONS hWnd,IDI_LISWATCH;set dlg icon.
			
			 ;Update our contents periodically
			 invoke SetTimer,hWnd, g_uTimerId, TIMER_DELAY, NULL
			 mov g_uTimerId,eax
			 
			 ;Make our window on top of all others
   			 invoke SetWindowPos,hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE

		.elseif eax == WM_RBUTTONDOWN
			chMB SADD("To monitor a specific thread, click the left mouse button in the main window and release it in the desired window.\nTo monitor all threads, double-click the left mouse button in the main window.")
		.elseif eax == WM_LBUTTONDOWN
			;If we're attached to a thread, detach from it
			.if g_dwThreadIdAttachTo != 0
				invoke GetCurrentThreadId
				invoke AttachThreadInput,eax, g_dwThreadIdAttachTo, FALSE
			.ENDIF
				
			;Set capture to ourself and change the mouse cursor
			invoke SetCapture,hWnd
			invoke LoadCursor,hInstance,IDC_EYES
			invoke SetCursor,eax
					
		.elseif eax == WM_LBUTTONUP
			invoke GetCapture
			.if eax == hWnd
				;If we had mouse capture set, get the ID of the thread that
                ;created the window that is under the mouse cursor.
                invoke GetMessagePos
                mov ecx,eax
                and ecx,0ffffh                
                shr eax,16
                mov pt.x,ecx
                mov pt.y,eax
                invoke ReleaseCapture
                invoke GetDesktopWindow
				mov hTemp,eax
                invoke ChildWindowFromPointEx,hTemp,pt.x,pt.y, CWP_SKIPINVISIBLE
				invoke GetWindowThreadProcessId,eax,NULL
				mov g_dwThreadIdAttachTo,eax
				
				invoke GetCurrentThreadId
				.if eax == g_dwThreadIdAttachTo
					;The mouse button is released on one of our windows; 
                    ;monitor local-input state on a system-wide basis
			        mov g_dwThreadIdAttachTo,0
				.else
					;The mouse button is released on a window that our thread didn't
         			;create; monitor local input state for that thread only.
					invoke GetCurrentThreadId
					invoke AttachThreadInput,eax, g_dwThreadIdAttachTo, TRUE					
				.endif
			.endif
		.elseif eax == WM_TIMER
			invoke lstrcpy,addr szBuf,SADD("System-wide")
			invoke GetForegroundWindow
			mov hwndForeground,eax
			push g_dwThreadIdAttachTo
			pop  dwThreadIdAttachTo
			
			.if dwThreadIdAttachTo == 0					
				;If monitoring local input state system-wide, attach our input
      			;state to the thread that created the current foreground window.
				invoke GetWindowThreadProcessId,hwndForeground, NULL
				mov dwThreadIdAttachTo,eax
				invoke GetCurrentThreadId
				invoke AttachThreadInput,eax, dwThreadIdAttachTo, TRUE
			
			.else				
				invoke wsprintf,addr szBuf, SADD("0x%08x"), dwThreadIdAttachTo							
			.endif
			
			invoke GetDlgItem,hWnd, IDC_THREADID
			mov hTemp,eax
			invoke SetWindowText,hTemp,addr szBuf
			
			invoke GetFocus
			mov hTemp,eax
			invoke CalcWndText,hTemp,addr szBuf,sizeof szBuf
			invoke GetDlgItem,hWnd, IDC_WNDFOCUS
			mov hTemp,eax
			invoke SetWindowText,hTemp,addr szBuf
			
			invoke GetActiveWindow
			mov hTemp,eax
			invoke CalcWndText,hTemp,addr szBuf,sizeof szBuf
			invoke GetDlgItem,hWnd, IDC_WNDACTIVE
			mov hTemp,eax
			invoke SetWindowText,hTemp,addr szBuf
			
			invoke GetCapture
			mov hTemp,eax
			invoke CalcWndText,hTemp,addr szBuf,sizeof szBuf
			invoke GetDlgItem,hWnd, IDC_WNDCAPTURE			
			mov hTemp,eax
			invoke SetWindowText,hTemp,addr szBuf
			
			invoke CalcWndText,hwndForeground,addr szBuf,sizeof szBuf
			invoke GetDlgItem,hWnd, IDC_WNDFOREGRND
			mov hTemp,eax
			invoke SetWindowText,hTemp,addr szBuf
			
			.if g_dwThreadIdAttachTo == 0
				;If monitoring local input state system-wide, detach our input
     			;state from the thread that created the current foreground window.
				invoke GetCurrentThreadId
				invoke AttachThreadInput,eax, dwThreadIdAttachTo, FALSE
			.endif
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.if	eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start
